package jobqueue

import (
	"gorm.io/gorm"
	"time"
)

type JobStats struct {
	JobID        JobID       `json:"job_id" gorm:"primaryKey"`
	RunCount     int         `json:"run_count"`
	SuccessCount int         `json:"success_count"`
	ErrorCount   int         `json:"error_count"`
	TimeMetrics  TimeMetrics `json:"time_metrics" gorm:"embedded;embeddedPrefix:time_metrics_"`
	CreatedAt    time.Time
	UpdatedAt    time.Time
	DeletedAt    gorm.DeletedAt `gorm:"index"`
}

type TimeMetrics struct {
	AvgRunTime   time.Duration `json:"avg"`
	MaxRunTime   time.Duration `json:"max"`
	MinRunTime   time.Duration `json:"min"`
	TotalRunTime time.Duration `json:"total"`
}

func (JobStats) TableName() string {
	return globalTableNamePrefix + "job_stats"
}
